unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, WinSock, Registry, StrUtils, math, printers;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    fio: TLabeledEdit;
    Label1: TLabel;
    tel: TLabeledEdit;
    zdanie: TLabeledEdit;
    etaj: TLabeledEdit;
    kab: TLabeledEdit;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure kabKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;

function CheckRun: boolean;
procedure GetSysInfo;

var info: record
hostname: string;
username: string;
ip: string;
path: string;
syspath: string;
end;

function LocalIP: string;

var ready: boolean = false;

implementation

uses cxcpu40;

{$R *.dfm}

const directory = '\\report_server\mm$\Basa\';

var NT: boolean;


type
  COMPUTER_NAME_FORMAT = (
    ComputerNameNetBIOS,
    ComputerNameDnsHostname,
    ComputerNameDnsDomain,
    ComputerNameDnsFullyQualified,
    ComputerNamePhysicalNetBIOS,
    ComputerNamePhysicalDnsHostname,
    ComputerNamePhysicalDnsDomain,
    ComputerNamePhysicalDnsFullyQualified,
    ComputerNameMax);


var GetComputerNameEx: function (ComputerNameFormat: COMPUTER_NAME_FORMAT;  lpNameBuffer: PAnsiChar; nSize: PLongWord): BOOL; stdcall;



function WinUser: string;
var size: longword; UN: PChar; username: string;
begin

if not nt then
begin
size := 255;
end else
begin
size := 0;
UN := nil;
Windows.GetUserName(UN, size);
end;

if size > 0 then
begin
GetMem(Un, size + 1);
FillChar(Un^, size + 1 , 0);
Windows.GetUserName(UN, size);
username := UN;
FreeMem(UN);
end else begin
username := '';
end;

result := UserName;
end;

function GetComputerNameExWrap(ComputerNameFormat: COMPUTER_NAME_FORMAT): string;
var
  ComputerName: PChar;
  ComputerNameLen: DWord; Kernel: Cardinal;
begin


Kernel := LoadLibrary('kernel32.dll');
GetComputerNameEx := Windows.GetProcAddress(Kernel,  'GetComputerNameExA');

 ComputerNameLen := 0;
 ComputerName := nil;

 Result := '';

 GetComputerNameEx(ComputerNameFormat, ComputerName, @ComputerNameLen);

 if ComputerNameLen > 0 then begin

 GetMem(ComputerName, ComputerNameLen + 1);
 FillChar(ComputerName^, ComputerNameLen + 1, 0);

  if not (GetComputerNameEx(ComputerNameFormat, ComputerName, @ComputerNameLen)) then
    ComputerName := '';

  Result := ComputerName;

  FreeMem(ComputerName);
 end;


FreeLibrary(Kernel);



end;

function ClassicGetComputerName: string;
var size: longword; TN: PChar; hostname: string;
begin
size := MAX_COMPUTERNAME_LENGTH + 1;
setlength(hostname, size + 1);
GetMem(TN, size + 1);
FillChar(TN^, size + 1, 0);
windows.GetComputerName(TN, size);
hostname := TN;
FreeMem(TN);
setlength(hostname, size);
Result := HostName;

end;


function NTGetComputerName: string;
begin
Result :=  Trim(GetComputerNameExWrap(ComputerNameNetBIOS));

if Result = '' then Result := ClassicGetComputerName;

end;




function isWin9x: Bool; {True=Win9x}{False=NT}
asm
  xor eax, eax
  mov ecx, cs
  xor cl, cl
  jecxz @@quit
  inc eax
  @@quit:
end;

function CheckRun: boolean;
begin
nt := not isWin9x;
if nt then info.hostname := NtGetComputerName else
info.hostname := ClassicGetComputerName;

info.path := directory + info.hostname + '.txt';
info.syspath := directory + info.hostname + '.nfo';
Result := fileexists(info.path);

end;


function RdTSC : int64; register; 
asm 
  db   $0f, $31 
end;                                                  

function GetCpuSpeedA : integer;
var
  hF, T, et, sc : int64;
    PriorityClass, Priority: Integer;
begin

Result := 0;

if nt then
SetThreadAffinityMask(GetCurrentThread, 1);


  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);


if  QueryPerformanceFrequency(hF)
then                                                              // HiTicks / second
if  QueryPerformanceCounter(T)
then
begin                                                         // Determine start HiTicks
  et := T + hF;                                                  // (Cycles are passing, but we can still USE them!)
  sc := RdTSC;                                                          // Get start cycles
  repeat                                                     // Use Hi Perf Timer to loop for 1 second
   if QueryPerformanceCounter(T) then continue;              // Check ticks NOW
  until (T >= et);                                           //  Break the moment we equal or exceed et

  Result := Round((RdTSC - sc) / 1000000);

  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);


                                                           // Get stop cycles and calculate result
end;



function GetCPUSpeedB: integer;
const
  DelayTime = 500;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin

Result := 0;

try

if nt then

SetThreadAffinityMask(GetCurrentThread, 1);

  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10); 
  asm 
    dw 310Fh // rdtsc 
    mov TimerLo, eax 
    mov TimerHi, edx 
  end; 

  Sleep(DelayTime);

  asm
    dw 310Fh // rdtsc 
    sub eax, TimerLo 
    sbb edx, TimerHi 
    mov TimerLo, eax 
    mov TimerHi, edx 
  end; 

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Result := Round(TimerLo / (1000.0 * DelayTime));

  except end; 
end;

function WinProduct: string;
var
  r: TRegistry;
begin
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  case nt of
    False:
      r.OpenKeyReadOnly ('\SOFTWARE\Microsoft\Windows\CurrentVersion');
    True:
      r.OpenKeyReadOnly  ('\SOFTWARE\Microsoft\Windows NT\CurrentVersion');
    end;
  if R.ValueExists('ProductName') then
    Result := r.ReadString('ProductName')
  else
    Result := '/';
  r.CloseKey;
  r.Free;
end;


function WinVer: string;
var
  r: TRegistry;
begin
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  case nt of
    False:
      begin
      r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows\CurrentVersion');
      if R.ValueExists('Version') then
        Result := r.ReadString('Version')
      else
        Result := '/';
      end;
    True:
      begin
      r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows NT\CurrentVersion');
      if R.ValueExists('CurrentVersion') then
        Result := r.ReadString('CurrentVersion')
      else
        Result := '/';
      end;

    end;
  r.CloseKey;
  r.Free;
end;


function WinVerNum: string;
var
  r: TRegistry;
begin
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows\CurrentVersion');
  if R.ValueExists('VersionNumber') then
    Result := r.ReadString('VersionNumber')
  else
    Result := '/';
  r.CloseKey;
  r.Free;
end;

function WinSP: string;
var
  r: TRegistry;
begin
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows NT\CurrentVersion');
  if R.ValueExists('BuildLab') then
    Result := r.ReadString('BuildLab')
  else
    Result := '/';
  r.CloseKey;
  r.Free;
end;

function WinID: string;
var
  r: TRegistry;
begin
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  case nt of
    False:
      r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows\CurrentVersion');
    True:
      r.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows NT\CurrentVersion');
    end;
  if R.ValueExists('ProductID') then
    Result := r.ReadString('ProductID')
  else
    Result := '/';
  r.CloseKey;
  r.Free;
end;


Function FixBIOS (s: string): string;
var i: integer; lastsp: boolean;
begin
Result := '';
lastsp:= false;


for I := 1 to Length(s) do
begin

case s[i] of
'A'..'Z', 'a'..'z', '.', '(',')' , '@','#','!','0'..'9',':',',':
begin
result := result + s[i];
lastsp := false;
end;

' ': begin
if not lastsp then
begin
lastsp := true;
result := result + s[i];
end;
end;

end;

end;

Result := Trim(Result);
end;

function getharddrives: string;
var
  dset, i: longint;
begin
  Result := '';
  dset   := getlogicaldrives;
  for i := 0 to 31 do
    if dset shr i and 1 = 1 then
      if getdrivetype(PChar(char(i + 65) + string(':\'))) = 3 then
        Result := Result + char(i + 65);
end;

function BIOSInfo: string;
var
  sMainBoardBiosCopyright, sMainBoardBiosDate, sMainBoardBiosName,
  sMainBoardBiosSerialNo: string;

begin
  try
    sMainBoardBiosName      := string(PChar(Ptr($FE061)));
    sMainBoardBiosCopyright := string(PChar(Ptr($FE091)));
    sMainBoardBiosDate      := string(PChar(Ptr($FFFF5)));
    sMainBoardBiosSerialNo  := string(PChar(Ptr($FEC71))); 
  except
    sMainBoardBiosName      := '';
    sMainBoardBiosCopyright := '';
    sMainBoardBiosDate      := '';
    sMainBoardBiosSerialNo  := '';
    end;

Result := Format ('%s %s %s %s', [sMainBoardBiosName,sMainBoardBiosCopyright,sMainBoardBiosDate,sMainBoardBiosSerialNo ]);
Result := FixBIOS(Result);

end;



function  BiosInfoNT: string;
var
  Registryv: TRegistry;
  RegPath: string;
  str: PChar;
begin
Result := '';
  RegPath   := '\HARDWARE\DESCRIPTION\System';
  registryv := TRegistry.Create;
  registryv.rootkey := HKEY_LOCAL_MACHINE;
  try
    registryv.OpenkeyReadOnly(RegPath);
      Result := Result + RegistryV.ReadString('SystemBiosDate');
    Str := StrAlloc(256);
    RegistryV.ReadBinaryData('SystemBiosVersion', str^, 4096);
     Result := Result + ' ' + str;
    StrPCopy(str, StringOfChar(' ', 255));
    Result := Result + ' ' + RegistryV.ReadString('VideoBiosDate');
RegistryV.ReadBinaryData('VideoBiosVersion', str^, 4096);
     Result := Result + ' ' + str;
    StrDispose(str);
  except
    end;
  Registryv.Free;
 Result := FixBIOS(Result);
end;

function MemoryStatusClassic: integer;
var lpMemoryStatus: TMemoryStatus;
begin
lpMemoryStatus.dwLength := sizeof(lpMemoryStatus);
GlobalMemoryStatus(lpMemoryStatus);
Result := Round(lpMemoryStatus.dwTotalPhys /1024/1024)

end;


type   DWORDLONG = UInt64;

  _MEMORYSTATUSEX = packed record
    dwLength: DWORD;
    dwMemoryLoad: DWORD;
    ullTotalPhys: DWORDLONG;
    ullAvailPhys: DWORDLONG;
    ullTotalPageFile: DWORDLONG;
    ullAvailPageFile: DWORDLONG;
    ullTotalVirtual: DWORDLONG;
    ullAvailVirtual: DWORDLONG;
    ullAvailExtendedVirtual: DWORDLONG;
  end;


  TMemoryStatusEx = _MEMORYSTATUSEX;
  MEMORYSTATUSEX = _MEMORYSTATUSEX;

type
  PMemoryStatusEx = ^TMemoryStatusEx;


var GlobalMemoryStatusEx: function (var lpBuffer : TMEMORYSTATUSEX): BOOL; stdcall;

function MemoryStatusNT: integer;
var lpMemoryStatus: TMemoryStatusEx; Kernel: Cardinal;
begin



Kernel := LoadLibrary('kernel32.dll');
GlobalMemoryStatusEx := Windows.GetProcAddress(Kernel,  'GlobalMemoryStatusEx');

lpMemoryStatus.dwLength := sizeof(lpMemoryStatus);

if GlobalMemoryStatusEx(lpMemoryStatus) then
Result := Round(lpMemoryStatus.ullTotalPhys  /1024/1024)
else Result := 0;



FreeLibrary(Kernel);
end;


function GetDefaultPrinterName : string;
begin

Result := '';

 if  Printer.Printers.Count > 0 then
 begin

   if (Printer.PrinterIndex > 0)then begin
     Result :=  Printer.Printers [Printer.PrinterIndex];
  end;
 end;


  end;

procedure GetSysInfo;
var SL: TStringList;
 fbc,tb,total:int64;s:string;i:integer;
 speedA, speedB, speed: integer;
begin

SL := TStringList.Create;

speedA := GetCPUSpeedA;
speedB := GetCPUSpeedB;

speed := MAX(speedA, speedB);


SL.Add(Format('%d', [speed]));



if Nt then
SL.Add('NT')
else
SL.Add('9x');

  s := getharddrives;

  total:=0;
  fbc:=0;
  tb:=0;

  for i := 1 to length(s) do
    begin

    if nt then
    begin
    SysUtils.GetDiskFreeSpaceEx(PChar(s[i] + ':\'), fbc, tb, nil);
   total := total + tb;
    end

    else
    begin
  total := total +  SysUtils.DiskSize(Byte(S[i]) -  Byte('A')  + 1);
    end;


    end;


if nt then
SL.Add(Format('%d', [MemoryStatusNT]))
else
SL.Add(Format('%d', [MemoryStatusClassic]));

SL.Add(FixBIOS(cxCpu[0].Name.AsString));
SL.Add(format('%d',[Round(total/1024/1024/1024)]));
SL.Add(WinProduct);
SL.Add(WinVer);
SL.Add(WinVerNum);
SL.Add(WinSP);
SL.Add(WinID);
if NT then SL.Add(BiosInfoNT)
else SL.Add(BiosInfo);
SL.Add(WinUser);
SL.Add(LocalIP);
SL.Add(GetDefaultPrinterName);
try
SL.SaveToFile(info.syspath);
except
end;
SL.Free;


end;

function LocalIP: string;
type pu_long = ^u_long;
var varTWSAData : TWSAData;
varPHostEnt : PHostEnt;
varTInAddr : TInAddr;
namebuf : Array[0..255] of ansichar;
begin
try
try
If WSAStartup($101,varTWSAData) <> 0 Then
Result := ''
Else Begin
gethostname(namebuf,sizeof(namebuf));
varPHostEnt := gethostbyname(namebuf);
varTInAddr.S_addr := u_long(pu_long(varPHostEnt^.h_addr_list^)^);
Result := inet_ntoa(varTInAddr);
End;
except
Result := '';
end;
finally
WSACleanup;
end;
end;


type
  TExplodeArray = array of String;

function Explode(const cSeparator, vString: String): TExplodeArray;
var
  i: Integer;
  S: String;
begin
  S := vString;
  SetLength(Result, 0);
  i := 0;
  while Pos(cSeparator, S) > 0 do begin
    SetLength(Result, Length(Result) +1);
    Result[i] := Trim(Copy(S, 1, Pos(cSeparator, S) -1));
    Inc(i);
    S := Copy(S, Pos(cSeparator, S) + Length(cSeparator), Length(S));
  end;
  SetLength(Result, Length(Result) +1);
  Result[i] := Trim(Copy(S, 1, Length(S)));
end;


function TrimName(s: String): String;
var
  i, n: integer;
  t: String;
  sstart, send: integer; lastspace: boolean;
begin


  t := Trim(UpperCase(s, loUserLocale));

  Result := '';


  sstart := -1;

  for I := 1 to length(t) do
  begin
    case (t[i]) of
      '', ''..'':
      begin
        if sstart = -1 then
          sstart := i else
             send := i;

      end;

      #$20:
      begin
        {-}
      end;

    end;
  end;


  lastspace := false;

 for I := 1 to length(t) do
  begin
    case (t[i]) of
    '', ''..'':
      begin
     result := result + t[i];
      lastspace := false;
      end;

      ' ':
      begin
      if (i in [sstart + 1..send - 1]) and (lastspace = false) then
      begin
      result := result + t[i];
      lastspace := true;
      end;

      end;

    end;
  end;


end;



procedure TForm1.BitBtn1Click(Sender: TObject);
var SL: TStringList;  EA: TExplodeArray;  i: integer; Chk: boolean;
begin


fio.text := TrimName(Fio.Text);


if
(
(trim(fio.Text) = '') or (trim(fio.Text) = '') or (trim(zdanie.Text) = '') or (trim(kab.Text) = '')
)
 then begin
 MessageBox(handle, ',   ', ' ', MB_ICONEXCLAMATION + MB_OK);
 exit;
 end;


 EA := Explode(' ',FIO.Text);

 Chk := True;

if Length(EA) in [3..4] then
begin

for I := 0 to Length(EA) - 1 do
  begin
  if Length(EA[i]) < 2 then
  begin
  Chk := False;
  break;
  end;
  end;

end else begin
Chk := False;
end;

 if Chk = false then begin
 MessageBox(handle, ',  ... ,    !', ' ', MB_ICONEXCLAMATION + MB_OK);
 exit;
 end;

 ready := true;

SL := TStringList.Create;
Sl.Add(info.hostname);
Sl.Add(info.username);
Sl.Add(info.ip);
//Sl.Add(info.path);
Sl.Add(trim(fio.Text));
Sl.Add(trim(tel.Text));
Sl.Add(trim(zdanie.Text));
Sl.Add(trim(etaj.Text));
Sl.Add(trim(kab.Text));

try
SL.SaveToFile(info.path);
except

end;

SL.Free;


MessageBox(handle, '    ', '', MB_ICONINFORMATION + MB_OK);

close;

end;





procedure TForm1.FormActivate(Sender: TObject);
begin
onactivate := nil;

ready := false;

info.username := WinUser;

info.ip := LocalIP;


if fio.CanFocus then
begin

try

fio.SetFocus;
except

end;

end;

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

if ready then begin

canclose := true;
end else begin

canclose := MessageBox(handle, '     .'#13#10'       '#13#10'        ?', '  ', MB_YESNO+ MB_ICONWARNING) = IDYES;

end;

end;

procedure TForm1.kabKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
if key = vk_return then
begin
form1.SelectNext(sender as TWinControl, true, true);
end;

end;

end.
