unit client;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, ExtCtrls, Grids, DBGrids, StdCtrls, ComCtrls, Menus, ComObj;

type
  TForm1 = class(TForm)
    DataSource: TDataSource;
    Panel2: TPanel;
    ADOConnection: TADOConnection;
    ADOQuery: TADOQuery;
    Panel1: TPanel;
    Splitter1: TSplitter;
    DBGrid: TDBGrid;
    Label1: TLabel;
    ft: TComboBox;
    find: TEdit;
    Label2: TLabel;
    SubSearch: TCheckBox;
    StatusBar: TStatusBar;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ExQuery: TADOQuery;
    MSExcel1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBGridTitleClick(Column: TColumn);
    procedure DBGridCellClick(Column: TColumn);
    procedure findKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DBGridKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DBGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure MSExcel1Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure OpenFull;
    procedure DisplayInfo;
  end;

var
  Form1: TForm1;

const dbdir = '\\report_server\mm$\Basa\DB\';

implementation

uses info;

{$R *.dfm}



procedure TForm1.DisplayInfo;
var Form2: TForm2; i: integer;
begin

Form2 := TForm2.Create(Form1);
Form2.VLE.Strings.Clear;

for i := dbgrid.FieldCount-1 downto 0 do
  begin

  Form2.VLE.InsertRow(DBGRID.Columns[i].Title.Caption, DBGRID.Fields[i].Text, False);

  end;

Form2.ShowModal;
Form2.Free;
end;

procedure TForm1.OpenFull;
var c: TColumn;  i: integer;
begin

C := dbgrid.Columns.Add;
C.Title.Caption := '...';
C.FieldName := 'FIO';
c.Width := 180;


C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'HOST';
c.Width := 100;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'USER';
c.Width := 180;

C := dbgrid.Columns.Add;
C.Title.Caption := 'IP';
C.FieldName := 'IP';
c.Width := 170;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'TEL';
c.Width := 170;

C := dbgrid.Columns.Add;
C.Title.Caption := ' (MSE)';
C.FieldName := 'TEL2';
c.Width := 170;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'EMAIL';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'ZDAN';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'ETAJ';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'KAB';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'SPEED';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := ' ';
C.FieldName := 'TYPE';
c.Width := 100;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'RAM';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'CPU';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'HDD';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := 'C';
C.FieldName := 'OS';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '.';
C.FieldName := 'OSVER';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '.9x';
C.FieldName := 'W9XVER';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := ' ';
C.FieldName := 'OSBUILD';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := 'ID ';
C.FieldName := 'OSID';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := 'BIOS';
C.FieldName := 'BIOS';
c.Width := 150;

C := dbgrid.Columns.Add;
C.Title.Caption := '';
C.FieldName := 'PRINTER';
c.Width := 150;

adoquery.SQL.Text := 'SELECT * FROM USERS ORDER BY FIO';
adoquery.Open;
adoquery.Last;
StatusBar.Panels[0].Text := Format(': %d', [adoquery.RecordCount]);

ft.Items.Clear;
for I := 0 to dbgrid.Columns.Count - 1 do
ft.Items.Add(dbgrid.Columns[i].Title.Caption);

end;

procedure TForm1.DBGridCellClick(Column: TColumn);
var i: integer; fn: string;
begin
ft.ItemIndex := column.Index;
end;

procedure TForm1.DBGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var Form2: TForm2; i: integer;
begin

if (key  = vk_Return) and (ssCtrl in Shift) then
begin
DisplayInfo;
end;


end;

procedure TForm1.DBGridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbMiddle then DisplayInfo;
end;

procedure TForm1.DBGridTitleClick(Column: TColumn);
begin
adoquery.SQL.Text := Format('SELECT * FROM USERS ORDER BY %s', [Column.FieldName]);
adoquery.Open;
adoquery.Last;
StatusBar.Panels[0].Text := Format(': %d', [adoquery.RecordCount]);
end;

procedure TForm1.findKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var p: TParameter;
  begin

  if ft.ItemIndex = -1 then exit;


if key = vk_return then
begin
adoquery.SQL.Text := Format('SELECT * FROM USERS WHERE UCASE(%s) LIKE :SRC',[dbgrid.Columns[ft.ItemIndex].FieldName]);
  p := adoquery.Parameters.ParamByName('SRC');
  p.DataType := ftString;
  p.Size := 70;
  if subsearch.Checked then
  p.Value := '%' + UpperCase(find.Text, loUserLocale) + '%' else
  p.Value := UpperCase(find.Text, loUserLocale) + '%';
  adoquery.Open;
  adoquery.Last;
  StatusBar.Panels[0].Text := Format(': %d', [adoquery.RecordCount]);
end;

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
onactivate := nil;
adoconnection.ConnectionString :=
    'DRIVER=Microsoft dBase Driver (*.dbf);DriverID=533;FIL=dBase 5.0;DefaultDir=' + dbdir;
 OpenFull;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
adoconnection.Close;
end;

procedure TForm1.MSExcel1Click(Sender: TObject);
  var
    ExcelApp, Workbook, Range, Cell1, Cell2, ArrayData: variant;
    TemplateFile: string;
    BeginCol, BeginRow, i, j, n: integer;
    RowCount, ColCount, RC, Total: integer; FDef: TStringList;
begin

ExQuery.SQL.Text := 'SELECT COUNT (HOST) AS COUNT FROM USERS;';
ExQuery.Open;
Total := ExQuery.FieldByName('COUNT').AsInteger;

Exquery.SQL.Text := 'SELECT * FROM USERS ORDER BY HOST;';
Exquery.Open;


RowCount := Total;
ColCount := DbGrid.Columns.Count;

 ExcelApp := CreateOleObject('Excel.Application');

    //   Excel  ,    
    ExcelApp.Application.EnableEvents := False;

    //    (Workbook)
    //    ,  Workbook := ExcelApp.WorkBooks.Add('C:\MyTemplate.xls');
    Workbook := ExcelApp.WorkBooks.Add;

    //   ,    
    ArrayData := VarArrayCreate([1, RowCount, 1, ColCount], varVariant);

    ExQuery.First;


    FDef := TStringList.Create;

    for i := 0 to DBGrid.Columns.Count - 1 do
      FDef.Add(DBGrid.Columns[i].FieldName);

    i:= 1;

    while Not ExQuery.Eof do
    begin
    for n := 0 to ColCount - 1 do
      begin
      ArrayData[i, n + 1] := ExQuery.FieldByName(FDef[n]).AsString;
      end;

    inc(i);
    ExQuery.Next;
    end;

        //    ,     
    Cell1 := WorkBook.WorkSheets[1].Cells[2, 1];
    //    ,     
    Cell2 := WorkBook.WorkSheets[1].Cells[RowCount + 1,  ColCount];

    // ,     
    Range := WorkBook.WorkSheets[1].Range[Cell1, Cell2];

    //      
    //    
    Range.Value := ArrayData;

    for I := 0 to DbGrid.Columns.Count - 1 do
    WorkBook.WorkSheets[1].Cells[1, i + 1] := DbGrid.Columns[i].Title.Caption;

    Cell1 := WorkBook.WorkSheets[1].Cells[1, 1];
    Cell2 := WorkBook.WorkSheets[1].Cells[1, ColCount];
    Range := WorkBook.WorkSheets[1].Range[Cell1, Cell2];

    Range.Font.Bold:=1;
    Range.Font.Italic:=0;
    Range.Font.Size:=12;
    Range.Font.Color:=clNavy;


    Cell1 := WorkBook.WorkSheets[1].Cells[2, 1];
    Cell2 := WorkBook.WorkSheets[1].Cells[RowCount + 1,  ColCount];
    Range := WorkBook.WorkSheets[1].Range[Cell1, Cell2];
    Range.EntireColumn.AutoFit;

    Fdef.Clear;

    //  Excel 
    ExcelApp.Visible := True;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
ShowMessage(' '#13#10'() 2010 .');
end;

procedure TForm1.N7Click(Sender: TObject);
begin
keybd_event(vk_control,0,0,0);
keybd_event(vk_return,0,0,0);
keybd_event(vk_control,0,KEYEVENTF_KEYUP,0);
keybd_event(vk_return,0,KEYEVENTF_KEYUP,0);
end;

end.
